﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using System.ComponentModel;
using System.Diagnostics;

namespace UnboundFieldWithTemplate
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = new List<Data>
            {
                new Data { ServiceDateUTC = DateTime.Now },
                new Data { ServiceDateUTC = DateTime.Now.AddMonths(2) },
                new Data { ServiceDateUTC = DateTime.Now.AddMonths(4) },
                new Data { ServiceDateUTC = DateTime.Now.AddMonths(6) },
                new Data { ServiceDateUTC = DateTime.Now.AddMonths(8) },
                new Data { ServiceDateUTC = DateTime.Now.AddMonths(10) },
            };
        }
    }

    public class Data : INotifyPropertyChanged
    {
        private DateTime date;

        public DateTime ServiceDateUTC
        {
            get { return date; }
            set 
            { 
                date = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("ServiceDateUTC"));
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class IndexToTemplateConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            // dateTimeTemplate

            if ((int)values[1] % 2 == 0)
            {
                XamDataGrid grid = (values[0] as CellValuePresenter).Record.FieldLayout.DataPresenter as XamDataGrid;
                return grid.Resources["dateTimeTemplate"] as DataTemplate;
            }
            return Binding.DoNothing;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
